#ifndef __uaru_h__
#define __uaru_h__

#ifdef _MSC_VER
#ifdef COATIPROGRAM
#define UARU_API 
#else
#ifdef UARU_EXPORTS
#define UARU_API __declspec(dllexport)
#else
#define UARU_API __declspec(dllimport)
#endif
#endif
#else
#define UARU_API 
#endif


#include <cstddef>
using namespace std;

#define UARU void*

enum UARUState {UARU_NONE,UARU_OK,UARU_REDIRECT,UARU_MULTIPART,UARU_EOF,UARU_ERROR};

//! Opens an URL for reading (1) or writing (0). Username and password are optionally. 
UARU_API UARU ConnectURL(const char* url, int instream = 1, const char* username = nullptr, const char*  password = nullptr);

//! Retrieves data from the assotiated URL and writes it into the buffer. The bytes read are returned in buffersize. 
UARU_API UARUState GetData(const UARU pdsd, char* buffer, size_t& buffersize);

//! Writes data into the assotiated URL. The number of bytes in the the buffer is set by buffersize.
UARU_API UARUState WriteData(const UARU pdsd, char* buffer, size_t buffersize);

//! Returns some logging information. 
UARU_API const char* GetLog(const UARU pdsd);

//! Disconnects the URL from UARU and releases the allocated ressources.
UARU_API void DisconnectUARU(const UARU pdsd);

#endif //__uaru_h__